.. half_band_decimator_xs documentation

.. This file is protected by Copyright. Please refer to the COPYRIGHT file
   distributed with this source distribution.

   This file is part of OpenCPI <http://www.opencpi.org>

   OpenCPI is free software: you can redistribute it and/or modify it under the
   terms of the GNU Lesser General Public License as published by the Free
   Software Foundation, either version 3 of the License, or (at your option) any
   later version.

   OpenCPI is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
   A PARTICULAR PURPOSE. See the GNU Lesser General Public License for
   more details.

   You should have received a copy of the GNU Lesser General Public License
   along with this program. If not, see <http://www.gnu.org/licenses/>.


.. _half_band_decimator_xs:


Half Band Decimator (``half_band_decimator_xs``)
================================================
A decimating finite impulse response (FIR) filter, which makes use of symmetries in the taps and decimating factor of 2, to allow a more efficient implementation.

Design
------
A half band decimating filter is a specialised case of FIR filter design which has a decimating factor of 2. This results in a filter with an odd number of taps, with symmetry around the central tap, and all odd taps (except the central tap) being zero-valued. The zero taps may be skipped from the multiply accumulation, increasing the efficiency of the symmetric filter, with only a quarter of the number of multiplications required when compared to a normal FIR filter.

The basis of a symmetric FIR filter is described in :ref:`fir_filter_symmetric_xs` and a half band decimating filter then specialises this by skipping every second multiply-accumulate step.

As a half band decimating filter decimates by 2, the maximum passband specification is with the transition zone being at :math:`\frac{F_s}{4}` (where :math:`F_s` is the sampling frequency).

As a result, the generalized equation for the output :math:`y` of a symmetric FIR with an odd number of taps, :math:`N`, is expressed as:

.. math::
   :label: half_band_decimating_FIR_xs-equation

   y(n) = \left( \sum_{k=0}^\frac{N-3}{4} h[2k] \times (x[n-2k]+x[n-N+2k])\right) + h[\frac{N-1}{2}] \times x[n-\frac{N-1}{2}]

In :eq:`half_band_decimating_FIR_xs-equation`:

 * :math:`y[n]` is the output values.

 * :math:`x[n]` is the input values.

 * :math:`N` is the total number of taps.

 * :math:`h[k]` is the taps values, from :math:`0` to :math:`N - 1`.

When the zero taps are skipped, the equation :eq:`half_band_decimating_FIR_xs-equation`, results in folding of :math:`h(k)` taps around :math:`N/2`, and skipping every second calculation of :math:`h * x`, resulting in a quarter of the multiplications and additions that would have been required by a generalized FIR as shown in :ref:`fir_filter_symmetric_xs`. This structure is shown in :numref:`half_band_decimator-diagram`.

.. _half_band_decimator-diagram:

.. figure:: half_band_decimator.svg
   :alt: Block diagram showing symmetric FIR with half band decimation structure.
   :align: center

   Half band decimator FIR structure.

Note that the down-sample by 2 shown on the output is achieved by marking alternate samples valid/invalid (NB: this is specific to HDL, the RCC implementation has no concept of marking samples valid or invalid).

The ``half_band_decimator`` makes use of the ``fir_filter_symmetric`` primitive or shared class to low pass filter and decimate by 2 an input data stream.

As the symmetric FIR only uses half of the coefficients, only the second half are used for calculation :math:`h[\frac{N-1}{2}]` to :math:`h(N-1)`.

As the calculation involves rounding, there is a choice of rounding types that can be selected via the ``rounding_type`` property. The application should choose between half-up, half-even or truncation to minimise any bias. The truncation also has a choice to saturate the output generated by the component to the maximum or minimum value defined by the output type (e.g. -32,768 to 32,767 for short values). This can be achieved by using the ``truncate_with_saturation`` value.

References
~~~~~~~~~~

 * https://www.dsprelated.com/showarticle/1113.php

 * https://www.dsprelated.com/showcode/270.php

 * https://tomverbeure.github.io/2020/12/15/Half-Band-Filters-A-Workhorse-of-Decimation-Filters.html

 * W. Cho, D. Chung, Y. Kim, I. Kim and J. Jeon, "Design of FIR Half-Band Filter With Controllable Transition-Band Steepness," in IEEE Access, vol. 9, pp. 52144-52154, 2021, doi: 10.1109/ACCESS.2021.3069985. https://ieeexplore.ieee.org/document/9391655

.. spelling:word-list::
   Cho
   Jeon
   doi

Interface
---------
.. literalinclude:: ../specs/half_band_decimator_xs-spec.xml
   :language: xml
   :lines: 1,19-

Opcode Handling
~~~~~~~~~~~~~~~

   * Samples

      * Apply the received samples to the FIR cascade structure

      * Discard every second sample value after performing the filter function.

      * If an odd number of samples has been received, the last sample from the stream becomes the first sample of the next received set of samples. This odd sample will cause the time opcode to be delayed if the time is received before the next set of input samples.

      * Send the calculated samples to the output port.

         * If there is a delayed timestamp, a single sample is output, followed by the timestamp, then any remaining calculated samples are output.

   * Time

      * The received time is decremented by the ``group_delay``.

      * If the worker has a held time opcode, then add on a sample interval before forwarding. Otherwise forward the received time to the output port.

      **Note:** On reaching the end of the input, if the worker has a held time opcode this is forwarded to the output, any remaining input samples are discarded.

   * Sample_Interval

      * The output sample interval is calculated as the input sample interval multiplied by 2.

   * Flush

      * Input ``number_of_taps`` zeros into the sample buffer, outputting any samples generated. An additional zero sample is injected if the final sample would be decimated away.

      * Forward to output port.

   * Discontinuity

      * Reset processing buffer, setting history to zero.

      * Forward to output port.

   * Metadata

      * Forward to output port.

Properties
~~~~~~~~~~
.. ocpi_documentation_properties::

Ports
~~~~~
.. ocpi_documentation_ports::

   input: Primary input samples port.
   output: Primary output samples port.

Implementations
---------------
.. ocpi_documentation_implementations:: ../half_band_decimator_xs.rcc ../half_band_decimator_xs.hdl

Example Application
-------------------
.. literalinclude:: example_app.xml
   :language: xml
   :lines: 1,19-

Dependencies
------------
.. ocpi_documentation_include:: ../doc/fir_filter_symmetric/dependencies.inc

   |primitive_name|: Down-sample protocol interface delay primitive v2
   |primitive_link|: downsample_protocol_interface_delay_v2-primitive


Limitations
-----------
.. ocpi_documentation_include:: ../doc/fir_filter_symmetric/limitations.inc

   |component_name|: half_band_decimator_xs

Both implementations require the property ``number_of_taps`` to be set to a value which adheres to:

   :math:`N = (4n - 1)`.

   Where: N is the ``number_of_taps``, and :math:`n` is any positive number.

   Taps must be symmetrical with all odd taps (except the central tap) being zero-valued because there is no check within the worker.

Testing
-------
.. ocpi_documentation_test_platforms::

.. ocpi_documentation_test_result_summary::
